require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_AARCH64_ELF_MACHDEP_H_)) {
    eval 'sub _AARCH64_ELF_MACHDEP_H_ () {1;}' unless defined(&_AARCH64_ELF_MACHDEP_H_);
    if(defined(&__aarch64__)) {
	if(defined(&__AARCH64EB__)) {
	    eval 'sub ELF64_MACHDEP_ENDIANNESS () { &ELFDATA2MSB;}' unless defined(&ELF64_MACHDEP_ENDIANNESS);
	    eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2MSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
	} else {
	    eval 'sub ELF64_MACHDEP_ENDIANNESS () { &ELFDATA2LSB;}' unless defined(&ELF64_MACHDEP_ENDIANNESS);
	    eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2LSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
	}
	eval 'sub EF_ARM_RELEXEC () {0x1;}' unless defined(&EF_ARM_RELEXEC);
	eval 'sub EF_ARM_HASENTRY () {0x2;}' unless defined(&EF_ARM_HASENTRY);
	eval 'sub EF_ARM_INTERWORK () {0x4;}' unless defined(&EF_ARM_INTERWORK);
	eval 'sub EF_ARM_SYMSARESORTED () {0x4;}' unless defined(&EF_ARM_SYMSARESORTED);
	eval 'sub EF_ARM_APCS_26 () {0x8;}' unless defined(&EF_ARM_APCS_26);
	eval 'sub EF_ARM_DYNSYMSUSESEGIDX () {0x8;}' unless defined(&EF_ARM_DYNSYMSUSESEGIDX);
	eval 'sub EF_ARM_APCS_FLOAT () {0x10;}' unless defined(&EF_ARM_APCS_FLOAT);
	eval 'sub EF_ARM_MAPSYMSFIRST () {0x10;}' unless defined(&EF_ARM_MAPSYMSFIRST);
	eval 'sub EF_ARM_PIC () {0x20;}' unless defined(&EF_ARM_PIC);
	eval 'sub EF_ARM_ALIGN8 () {0x40;}' unless defined(&EF_ARM_ALIGN8);
	eval 'sub EF_ARM_NEW_ABI () {0x80;}' unless defined(&EF_ARM_NEW_ABI);
	eval 'sub EF_ARM_OLD_ABI () {0x100;}' unless defined(&EF_ARM_OLD_ABI);
	eval 'sub EF_ARM_SOFT_FLOAT () {0x200;}' unless defined(&EF_ARM_SOFT_FLOAT);
	eval 'sub EF_ARM_BE8 () {0x800000;}' unless defined(&EF_ARM_BE8);
	eval 'sub EF_ARM_EABIMASK () {0xff000000;}' unless defined(&EF_ARM_EABIMASK);
	eval 'sub EF_ARM_EABI_VER1 () {0x1000000;}' unless defined(&EF_ARM_EABI_VER1);
	eval 'sub EF_ARM_EABI_VER2 () {0x2000000;}' unless defined(&EF_ARM_EABI_VER2);
	eval 'sub EF_ARM_EABI_VER3 () {0x3000000;}' unless defined(&EF_ARM_EABI_VER3);
	eval 'sub EF_ARM_EABI_VER4 () {0x4000000;}' unless defined(&EF_ARM_EABI_VER4);
	eval 'sub EF_ARM_EABI_VER5 () {0x5000000;}' unless defined(&EF_ARM_EABI_VER5);
	eval 'sub ELF32_MACHDEP_ID_CASES () { &case  &EM_ARM:  &break;;}' unless defined(&ELF32_MACHDEP_ID_CASES);
	eval 'sub ELF64_MACHDEP_ID_CASES () { &case  &EM_AARCH64:  &break;;}' unless defined(&ELF64_MACHDEP_ID_CASES);
	eval 'sub ELF64_MACHDEP_ID () { &EM_AARCH64;}' unless defined(&ELF64_MACHDEP_ID);
	eval 'sub ELF32_MACHDEP_ID () { &EM_ARM;}' unless defined(&ELF32_MACHDEP_ID);
	eval 'sub KERN_ELFSIZE () {64;}' unless defined(&KERN_ELFSIZE);
	eval 'sub ARCH_ELFSIZE () {64;}' unless defined(&ARCH_ELFSIZE);
	eval 'sub R_AARCH64_NONE () {0;}' unless defined(&R_AARCH64_NONE);
	eval 'sub R_AARCH64_NONE2 () {256;}' unless defined(&R_AARCH64_NONE2);
	eval 'sub R_AARCH64_ABS64 () {257;}' unless defined(&R_AARCH64_ABS64);
	eval 'sub R_AARCH64_ABS32 () {258;}' unless defined(&R_AARCH64_ABS32);
	eval 'sub R_AARCH64_ABS16 () {259;}' unless defined(&R_AARCH64_ABS16);
	eval 'sub R_AARCH64_PREL64 () {260;}' unless defined(&R_AARCH64_PREL64);
	eval 'sub R_AARCH64_PREL32 () {261;}' unless defined(&R_AARCH64_PREL32);
	eval 'sub R_AARCH64_PREL16 () {262;}' unless defined(&R_AARCH64_PREL16);
	eval 'sub R_AARCH64_MOVW_UABS_G0 () {263;}' unless defined(&R_AARCH64_MOVW_UABS_G0);
	eval 'sub R_AARCH64_MOVW_UABS_G0_NC () {264;}' unless defined(&R_AARCH64_MOVW_UABS_G0_NC);
	eval 'sub R_AARCH64_MOVW_UABS_G1 () {265;}' unless defined(&R_AARCH64_MOVW_UABS_G1);
	eval 'sub R_AARCH64_MOVW_UABS_G1_NC () {266;}' unless defined(&R_AARCH64_MOVW_UABS_G1_NC);
	eval 'sub R_AARCH64_MOVW_UABS_G2 () {267;}' unless defined(&R_AARCH64_MOVW_UABS_G2);
	eval 'sub R_AARCH64_MOVW_UABS_G2_NC () {268;}' unless defined(&R_AARCH64_MOVW_UABS_G2_NC);
	eval 'sub R_AARCH64_MOVW_UABS_G3 () {269;}' unless defined(&R_AARCH64_MOVW_UABS_G3);
	eval 'sub R_AARCH64_MOVW_SABS_G0 () {270;}' unless defined(&R_AARCH64_MOVW_SABS_G0);
	eval 'sub R_AARCH64_MOVW_SABS_G1 () {271;}' unless defined(&R_AARCH64_MOVW_SABS_G1);
	eval 'sub R_AARCH64_MOVW_SABS_G2 () {272;}' unless defined(&R_AARCH64_MOVW_SABS_G2);
	eval 'sub R_AARCH64_LD_PREL_LO19 () {273;}' unless defined(&R_AARCH64_LD_PREL_LO19);
	eval 'sub R_AARCH64_ADR_PREL_LO21 () {274;}' unless defined(&R_AARCH64_ADR_PREL_LO21);
	eval 'sub R_AARCH64_ADR_PREL_PG_HI21 () {275;}' unless defined(&R_AARCH64_ADR_PREL_PG_HI21);
	eval 'sub R_AARCH64_ADR_PREL_PG_HI21_NC () {276;}' unless defined(&R_AARCH64_ADR_PREL_PG_HI21_NC);
	eval 'sub R_AARCH64_ADD_ABS_LO12_NC () {277;}' unless defined(&R_AARCH64_ADD_ABS_LO12_NC);
	eval 'sub R_AARCH64_LDST8_ABS_LO12_NC () {278;}' unless defined(&R_AARCH64_LDST8_ABS_LO12_NC);
	eval 'sub R_AARCH_TSTBR14 () {279;}' unless defined(&R_AARCH_TSTBR14);
	eval 'sub R_AARCH_CONDBR19 () {281;}' unless defined(&R_AARCH_CONDBR19);
	eval 'sub R_AARCH_JUMP26 () {282;}' unless defined(&R_AARCH_JUMP26);
	eval 'sub R_AARCH_CALL26 () {283;}' unless defined(&R_AARCH_CALL26);
	eval 'sub R_AARCH_LDST16_ABS_LO12_NC () {284;}' unless defined(&R_AARCH_LDST16_ABS_LO12_NC);
	eval 'sub R_AARCH_LDST32_ABS_LO12_NC () {285;}' unless defined(&R_AARCH_LDST32_ABS_LO12_NC);
	eval 'sub R_AARCH_LDST64_ABS_LO12_NC () {286;}' unless defined(&R_AARCH_LDST64_ABS_LO12_NC);
	eval 'sub R_AARCH64_MOVW_PREL_G0 () {287;}' unless defined(&R_AARCH64_MOVW_PREL_G0);
	eval 'sub R_AARCH64_MOVW_PREL_G0_NC () {288;}' unless defined(&R_AARCH64_MOVW_PREL_G0_NC);
	eval 'sub R_AARCH64_MOVW_PREL_G1 () {289;}' unless defined(&R_AARCH64_MOVW_PREL_G1);
	eval 'sub R_AARCH64_MOVW_PREL_G1_NC () {290;}' unless defined(&R_AARCH64_MOVW_PREL_G1_NC);
	eval 'sub R_AARCH64_MOVW_PREL_G2 () {291;}' unless defined(&R_AARCH64_MOVW_PREL_G2);
	eval 'sub R_AARCH64_MOVW_PREL_G2_NC () {292;}' unless defined(&R_AARCH64_MOVW_PREL_G2_NC);
	eval 'sub R_AARCH64_MOVW_PREL_G3 () {293;}' unless defined(&R_AARCH64_MOVW_PREL_G3);
	eval 'sub R_AARCH64_LDST128_ABS_LO12_NC () {299;}' unless defined(&R_AARCH64_LDST128_ABS_LO12_NC);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G0 () {300;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G0);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G0_NC () {301;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G0_NC);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G1 () {302;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G1);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G1_NC () {303;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G1_NC);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G2 () {304;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G2);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G2_NC () {305;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G2_NC);
	eval 'sub R_AARCH64_MOVW_GOTOFF_G3 () {306;}' unless defined(&R_AARCH64_MOVW_GOTOFF_G3);
	eval 'sub R_AARCH64_GOTREL64 () {307;}' unless defined(&R_AARCH64_GOTREL64);
	eval 'sub R_AARCH64_GOTREL32 () {308;}' unless defined(&R_AARCH64_GOTREL32);
	eval 'sub R_AARCH64_GOT_LD_PREL19 () {309;}' unless defined(&R_AARCH64_GOT_LD_PREL19);
	eval 'sub R_AARCH64_LD64_GOTOFF_LO15 () {310;}' unless defined(&R_AARCH64_LD64_GOTOFF_LO15);
	eval 'sub R_AARCH64_ADR_GOT_PAGE () {311;}' unless defined(&R_AARCH64_ADR_GOT_PAGE);
	eval 'sub R_AARCH64_LD64_GOT_LO12_NC () {312;}' unless defined(&R_AARCH64_LD64_GOT_LO12_NC);
	eval 'sub R_AARCH64_LD64_GOTPAGE_LO15 () {313;}' unless defined(&R_AARCH64_LD64_GOTPAGE_LO15);
	eval 'sub R_AARCH64_TLSGD_ADR_PREL21 () {512;}' unless defined(&R_AARCH64_TLSGD_ADR_PREL21);
	eval 'sub R_AARCH64_TLSGD_ADR_PAGE21 () {513;}' unless defined(&R_AARCH64_TLSGD_ADR_PAGE21);
	eval 'sub R_AARCH64_TLSGD_ADD_LO12_NC () {514;}' unless defined(&R_AARCH64_TLSGD_ADD_LO12_NC);
	eval 'sub R_AARCH64_TLSGD_MOVW_G1 () {515;}' unless defined(&R_AARCH64_TLSGD_MOVW_G1);
	eval 'sub R_AARCH64_TLSGD_MOVW_G0_NV () {516;}' unless defined(&R_AARCH64_TLSGD_MOVW_G0_NV);
	eval 'sub R_AARCH64_TLSLD_ADR_PREL21 () {517;}' unless defined(&R_AARCH64_TLSLD_ADR_PREL21);
	eval 'sub R_AARCH64_TLSLD_ADR_PAGE21 () {518;}' unless defined(&R_AARCH64_TLSLD_ADR_PAGE21);
	eval 'sub R_AARCH64_TLSLD_ADD_LO12_NC () {519;}' unless defined(&R_AARCH64_TLSLD_ADD_LO12_NC);
	eval 'sub R_AARCH64_TLSLD_MOVW_G1 () {520;}' unless defined(&R_AARCH64_TLSLD_MOVW_G1);
	eval 'sub R_AARCH64_TLSLD_MOVW_G0_NC () {521;}' unless defined(&R_AARCH64_TLSLD_MOVW_G0_NC);
	eval 'sub R_AARCH64_TLSLD_LD_PREL21 () {522;}' unless defined(&R_AARCH64_TLSLD_LD_PREL21);
	eval 'sub R_AARCH64_TLSLD_MOVW_DTPREL_G2 () {523;}' unless defined(&R_AARCH64_TLSLD_MOVW_DTPREL_G2);
	eval 'sub R_AARCH64_TLSLD_MOVW_DTPREL_G1 () {524;}' unless defined(&R_AARCH64_TLSLD_MOVW_DTPREL_G1);
	eval 'sub R_AARCH64_TLSLD_MOVW_DTPREL_G1_NC () {525;}' unless defined(&R_AARCH64_TLSLD_MOVW_DTPREL_G1_NC);
	eval 'sub R_AARCH64_TLSLD_MOVW_DTPREL_G0 () {526;}' unless defined(&R_AARCH64_TLSLD_MOVW_DTPREL_G0);
	eval 'sub R_AARCH64_TLSLD_MOVW_DTPREL_G0_NC () {528;}' unless defined(&R_AARCH64_TLSLD_MOVW_DTPREL_G0_NC);
	eval 'sub R_AARCH64_TLSLD_ADD_DTPREL_HI12 () {528;}' unless defined(&R_AARCH64_TLSLD_ADD_DTPREL_HI12);
	eval 'sub R_AARCH64_TLSLD_ADD_DTPREL_HI12 () {528;}' unless defined(&R_AARCH64_TLSLD_ADD_DTPREL_HI12);
	eval 'sub R_AARCH64_TLSLD_ADD_DTPREL_LO12 () {529;}' unless defined(&R_AARCH64_TLSLD_ADD_DTPREL_LO12);
	eval 'sub R_AARCH64_TLSLD_ADD_DTPREL_LO12_NC () {530;}' unless defined(&R_AARCH64_TLSLD_ADD_DTPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSLD_LDST8_DTPREL_LO12 () {531;}' unless defined(&R_AARCH64_TLSLD_LDST8_DTPREL_LO12);
	eval 'sub R_AARCH64_TLSLD_LDST8_DTPREL_LO12_NC () {532;}' unless defined(&R_AARCH64_TLSLD_LDST8_DTPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSLD_LDST16_DTPREL_LO12 () {533;}' unless defined(&R_AARCH64_TLSLD_LDST16_DTPREL_LO12);
	eval 'sub R_AARCH64_TLSLD_LDST16_DTPREL_LO12_NC () {534;}' unless defined(&R_AARCH64_TLSLD_LDST16_DTPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSLD_LDST32_DTPREL_LO12 () {535;}' unless defined(&R_AARCH64_TLSLD_LDST32_DTPREL_LO12);
	eval 'sub R_AARCH64_TLSLD_LDST32_DTPREL_LO12_NC () {536;}' unless defined(&R_AARCH64_TLSLD_LDST32_DTPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSLD_LDST64_DTPREL_LO12 () {537;}' unless defined(&R_AARCH64_TLSLD_LDST64_DTPREL_LO12);
	eval 'sub R_AARCH64_TLSLD_LDST64_DTPREL_LO12_NC () {538;}' unless defined(&R_AARCH64_TLSLD_LDST64_DTPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSIE_MOVW_GOTTPREL_G1 () {539;}' unless defined(&R_AARCH64_TLSIE_MOVW_GOTTPREL_G1);
	eval 'sub R_AARCH64_TLSIE_MOVW_GOTTPREL_G0_NC () {540;}' unless defined(&R_AARCH64_TLSIE_MOVW_GOTTPREL_G0_NC);
	eval 'sub R_AARCH64_TLSIE_ADR_GOTTPREL_PAGE21 () {541;}' unless defined(&R_AARCH64_TLSIE_ADR_GOTTPREL_PAGE21);
	eval 'sub R_AARCH64_TLSIE_LD64_GOTTPREL_LO12_NC () {542;}' unless defined(&R_AARCH64_TLSIE_LD64_GOTTPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSIE_LD_GOTTPREL_PREL19 () {543;}' unless defined(&R_AARCH64_TLSIE_LD_GOTTPREL_PREL19);
	eval 'sub R_AARCH64_TLSLE_MOVW_TPREL_G2 () {544;}' unless defined(&R_AARCH64_TLSLE_MOVW_TPREL_G2);
	eval 'sub R_AARCH64_MOVW_TPREL_G1 () {545;}' unless defined(&R_AARCH64_MOVW_TPREL_G1);
	eval 'sub R_AARCH64_MOVW_TPREL_G1_NC () {546;}' unless defined(&R_AARCH64_MOVW_TPREL_G1_NC);
	eval 'sub R_AARCH64_MOVW_TPREL_G0 () {547;}' unless defined(&R_AARCH64_MOVW_TPREL_G0);
	eval 'sub R_AARCH64_MOVW_TPREL_G0_NC () {548;}' unless defined(&R_AARCH64_MOVW_TPREL_G0_NC);
	eval 'sub R_AARCH64_ADD_TPREL_HI12 () {549;}' unless defined(&R_AARCH64_ADD_TPREL_HI12);
	eval 'sub R_AARCH64_ADD_TPREL_LO12 () {550;}' unless defined(&R_AARCH64_ADD_TPREL_LO12);
	eval 'sub R_AARCH64_ADD_TPREL_LO12_NC () {551;}' unless defined(&R_AARCH64_ADD_TPREL_LO12_NC);
	eval 'sub R_AARCH64_LDST8_TPREL_LO12 () {552;}' unless defined(&R_AARCH64_LDST8_TPREL_LO12);
	eval 'sub R_AARCH64_LDST8_TPREL_LO12_NC () {553;}' unless defined(&R_AARCH64_LDST8_TPREL_LO12_NC);
	eval 'sub R_AARCH64_LDST16_TPREL_LO12 () {554;}' unless defined(&R_AARCH64_LDST16_TPREL_LO12);
	eval 'sub R_AARCH64_LDST16_TPREL_LO12_NC () {555;}' unless defined(&R_AARCH64_LDST16_TPREL_LO12_NC);
	eval 'sub R_AARCH64_LDST32_TPREL_LO12 () {556;}' unless defined(&R_AARCH64_LDST32_TPREL_LO12);
	eval 'sub R_AARCH64_LDST32_TPREL_LO12_NC () {557;}' unless defined(&R_AARCH64_LDST32_TPREL_LO12_NC);
	eval 'sub R_AARCH64_LDST64_TPREL_LO12 () {558;}' unless defined(&R_AARCH64_LDST64_TPREL_LO12);
	eval 'sub R_AARCH64_LDST64_TPREL_LO12_NC () {559;}' unless defined(&R_AARCH64_LDST64_TPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSDESC_LD_PREL19 () {560;}' unless defined(&R_AARCH64_TLSDESC_LD_PREL19);
	eval 'sub R_AARCH64_TLSDESC_LD_PREL21 () {561;}' unless defined(&R_AARCH64_TLSDESC_LD_PREL21);
	eval 'sub R_AARCH64_TLSDESC_LD_PAGE21 () {562;}' unless defined(&R_AARCH64_TLSDESC_LD_PAGE21);
	eval 'sub R_AARCH64_TLSDESC_LD64_LO12 () {563;}' unless defined(&R_AARCH64_TLSDESC_LD64_LO12);
	eval 'sub R_AARCH64_TLSDESC_ADD_LO12 () {564;}' unless defined(&R_AARCH64_TLSDESC_ADD_LO12);
	eval 'sub R_AARCH64_TLSDESC_OFF_G1 () {565;}' unless defined(&R_AARCH64_TLSDESC_OFF_G1);
	eval 'sub R_AARCH64_TLSDESC_OFF_G0_NC () {566;}' unless defined(&R_AARCH64_TLSDESC_OFF_G0_NC);
	eval 'sub R_AARCH64_TLSDESC_LDR () {567;}' unless defined(&R_AARCH64_TLSDESC_LDR);
	eval 'sub R_AARCH64_TLSDESC_ADD () {568;}' unless defined(&R_AARCH64_TLSDESC_ADD);
	eval 'sub R_AARCH64_TLSDESC_CALL () {569;}' unless defined(&R_AARCH64_TLSDESC_CALL);
	eval 'sub R_AARCH64_TLSLE_LDST128_TPREL_LO12 () {570;}' unless defined(&R_AARCH64_TLSLE_LDST128_TPREL_LO12);
	eval 'sub R_AARCH64_TLSLE_LDST128_TPREL_LO12_NC () {571;}' unless defined(&R_AARCH64_TLSLE_LDST128_TPREL_LO12_NC);
	eval 'sub R_AARCH64_TLSLD_LDST128_DTPREL_LO12 () {572;}' unless defined(&R_AARCH64_TLSLD_LDST128_DTPREL_LO12);
	eval 'sub R_AARCH64_TLSLD_LDST128_DTPREL_LO12_NC () {573;}' unless defined(&R_AARCH64_TLSLD_LDST128_DTPREL_LO12_NC);
	eval 'sub R_AARCH64_P32_COPY () {180;}' unless defined(&R_AARCH64_P32_COPY);
	eval 'sub R_AARCH64_P32_GLOB_DAT () {181;}' unless defined(&R_AARCH64_P32_GLOB_DAT);
	eval 'sub R_AARCH64_P32_JUMP_SLOT () {182;}' unless defined(&R_AARCH64_P32_JUMP_SLOT);
	eval 'sub R_AARCH64_P32_RELATIVE () {183;}' unless defined(&R_AARCH64_P32_RELATIVE);
	eval 'sub R_AARCH64_P32_TLS_DTPREL () {184;}' unless defined(&R_AARCH64_P32_TLS_DTPREL);
	eval 'sub R_AARCH64_P32_TLS_DTPMOD () {185;}' unless defined(&R_AARCH64_P32_TLS_DTPMOD);
	eval 'sub R_AARCH64_P32_TLS_TPREL () {186;}' unless defined(&R_AARCH64_P32_TLS_TPREL);
	eval 'sub R_AARCH64_P32_TLSDESC () {187;}' unless defined(&R_AARCH64_P32_TLSDESC);
	eval 'sub R_AARCH64_P32_IRELATIVE () {188;}' unless defined(&R_AARCH64_P32_IRELATIVE);
	eval 'sub R_AARCH64_COPY () {1024;}' unless defined(&R_AARCH64_COPY);
	eval 'sub R_AARCH64_GLOB_DAT () {1025;}' unless defined(&R_AARCH64_GLOB_DAT);
	eval 'sub R_AARCH64_JUMP_SLOT () {1026;}' unless defined(&R_AARCH64_JUMP_SLOT);
	eval 'sub R_AARCH64_RELATIVE () {1027;}' unless defined(&R_AARCH64_RELATIVE);
	eval 'sub R_AARCH64_TLS_DTPREL64 () {1028;}' unless defined(&R_AARCH64_TLS_DTPREL64);
	eval 'sub R_AARCH64_TLS_DTPMOD64 () {1029;}' unless defined(&R_AARCH64_TLS_DTPMOD64);
	eval 'sub R_AARCH64_TLS_TPREL64 () {1030;}' unless defined(&R_AARCH64_TLS_TPREL64);
	eval 'sub R_AARCH64_TLSDESC () {1031;}' unless defined(&R_AARCH64_TLSDESC);
	eval 'sub R_AARCH64_IRELATIVE () {1032;}' unless defined(&R_AARCH64_IRELATIVE);
	eval 'sub R_TYPE {
	    my($name) = @_;
    	    eval q( &R_AARCH64_  $name);
	}' unless defined(&R_TYPE);
	eval 'sub R_TLS_TYPE {
	    my($name) = @_;
    	    eval q( &R_AARCH64_  $name  64);
	}' unless defined(&R_TLS_TYPE);
	eval 'sub PT_AARCH64_ARCHEXT () {( &PT_LOPROC + 0);}' unless defined(&PT_AARCH64_ARCHEXT);
	eval 'sub PT_AARCH64_UNWIND () {( &PT_LOPROC + 1);}' unless defined(&PT_AARCH64_UNWIND);
	eval 'sub SHF_ENTRYSECT () {0x10000000;}' unless defined(&SHF_ENTRYSECT);
	eval 'sub SHF_COMDEF () {0x80000000;}' unless defined(&SHF_COMDEF);
	eval 'sub SHT_AARCH64_ATTRIBUTES () {( &SHT_LOPROC + 3);}' unless defined(&SHT_AARCH64_ATTRIBUTES);
	if(defined(&_KERNEL)) {
	    if(defined(&ELFSIZE)) {
		eval 'sub ELF_MD_PROBE_FUNC () { &ELFNAME2( &aarch64_netbsd, &probe);}' unless defined(&ELF_MD_PROBE_FUNC);
	    }
	}
    }
 elsif(defined(&__arm__)) {
	require 'arm/elf_machdep.ph';
    }
}
1;
